#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int
main(int argc, char **argv)
{
    int myrank, nprocs;
    int bufsz, count, typesz;
    int sum, ans;
    int i, j;
    int *sbuf, *rbuf;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Comm_size(MPI_COMM_WORLD, &nprocs);
    MPI_Type_size(MPI_INT, &typesz);

    bufsz = 128 * 1024 * 1024;
    count = bufsz / typesz / nprocs;
    sbuf  = (int *) malloc(bufsz);
    rbuf  = (int *) malloc(bufsz);
    for (i = 0; i < count * nprocs; i++)
        sbuf[i] = myrank;

    MPI_Alltoall(sbuf, count, MPI_INT, rbuf, count, MPI_INT, MPI_COMM_WORLD);

    sum = ans = 0;
    for (i = 0; i < nprocs; i++)
        for (j = 0; j < count; j++)
            sum += rbuf[count * i + j] - i;
    MPI_Reduce(&sum, &ans, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);

    if (myrank == 0) {
        if (ans == 0)
            printf("# MPI Execution: Success\n");
        else
            printf("# MPI Execution: Fail\n");
    }

    MPI_Finalize();

    return 0;
}
