###
%{!?configure_options: %define configure_options %{nil}}
%{!?_with_valgrind: %define _with_valgrind 0}
%{!?_disable_valgrind: %define _disable_valgrind 0}

%if 0%{?rhel} != 0
%if 0%{_disable_valgrind} == 0
%define _with_valgrind 1
%endif
%endif
###

%define debug_package %{nil}
%define _with_valgrind 0
%define _prefix /opt/nec/ve
%define _libdir %{_prefix}/lib
%define _sysconfdir /etc%{_prefix}
%define __strip /opt/nec/ve/bin/nstrip
%define __objdump /opt/nec/ve/bin/nobjdump
%define configure_options CC=/opt/nec/ve/bin/gcc CFLAGS=-O2 CXXFLAGS=-O2 LDFLAGS= --host=x86_64-redhat-gnu
%define __global_ldflags %{nil}
%define __global_cflags %{nil}

AutoReqProv: no
Name: libibverbs-ve
Release: 1%{?dist}
Version: 1.0.1
Summary: A library for direct userspace use of RDMA (InfiniBand/iWARP) hardware

Group: System Environment/Libraries
License: GPLv2 or BSD
Url: http://openfabrics.org/
Source: http://openfabrics.org/downloads/verbs/libibverbs-%{version}.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%if %{_with_valgrind}
BuildRequires: valgrind-devel
%endif

%description
libibverbs is a library that allows userspace processes to use RDMA
"verbs" as described in the InfiniBand Architecture Specification and
the RDMA Protocol Verbs Specification.  This includes direct hardware
access from userspace to InfiniBand/iWARP adapters (kernel bypass) for
fast path operations.

For this library to be useful, a device-specific plug-in module should
also be installed.

%package devel
AutoReqProv: no
Summary: Development files for the libibverbs library
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
Provides: %{_prefix}/include/infiniband/verbs.h

%description devel
Header files for the libibverbs library.

%package devel-static
Summary: Static development files for the libibverbs library
Group: System Environment/Libraries

%description devel-static
Static libraries for the libibverbs library.

%package utils
Summary: Examples for the libibverbs library
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description utils
Useful libibverbs1 example programs such as ibv_devinfo, which
displays information about RDMA devices.

%prep
%setup -q -n libibverbs-1.0.1

%build
%if %{_with_valgrind}
%configure %{configure_options} --libdir=%{_libdir}/mlnx_ofed/valgrind --with-valgrind
make %{?_smp_mflags}
make DESTDIR=$RPM_BUILD_DIR/%{name}-%{version}/valgrind install
rm -f $RPM_BUILD_DIR/%{name}-%{version}/valgrind/%{_libdir}/mlnx_ofed/valgrind/*.*a
make clean
%endif

%configure %{configure_options}
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=%{buildroot} install
%if %{_with_valgrind}
mkdir -p %{buildroot}/%{_libdir}/mlnx_ofed
cp -a $RPM_BUILD_DIR/%{name}-%{version}/valgrind/%{_libdir}/mlnx_ofed/valgrind %{buildroot}/%{_libdir}/mlnx_ofed
%endif
# remove unpackaged files from the buildroot
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_libdir}/libibverbs*.so.*
%if %{_with_valgrind}
%{_libdir}/mlnx_ofed/valgrind/libibverbs*.so.*
%endif
%doc AUTHORS COPYING ChangeLog README

%files devel
%defattr(-,root,root,-)
%{_libdir}/lib*.so
%if %{_with_valgrind}
%{_libdir}/mlnx_ofed/valgrind/lib*.so
%endif
%{_includedir}/*
%{_mandir}/man3/*
%{_mandir}/man7/*

%files devel-static
%defattr(-,root,root,-)
%{_libdir}/*.a

%files utils
%defattr(-,root,root,-)
%{_bindir}/*
%{_mandir}/man1/*

%changelog
* Tue Sep 26 2017 NEC Corporation - 1.0.0
- Porting to VE architecture based on Mellanox OFED 3.4-2
