%{!?_with_valgrind: %define _with_valgrind 0}
%{!?_disable_valgrind: %define _disable_valgrind 0}

%if 0%{?rhel} != 0
%if 0%{_disable_valgrind} == 0
%define _with_valgrind 1
%endif
%endif

%define debug_package %{nil}
%define _with_valgrind 0
%define _prefix /opt/nec/ve
%define _libdir %{_prefix}/lib
%define _sysconfdir /etc%{_prefix}
%define __strip /opt/nec/ve/bin/nstrip
%define __objdump /opt/nec/ve/bin/nobjdump
%define configure_options CC=/opt/nec/ve/bin/gcc CFLAGS="-O3 -L%{_libdir}" LD=/opt/nec/ve/bin/nld LDFLAGS="-Wl,-rpath-link=%{_libdir}" --host=x86_64-redhat-gnu

AutoReqProv: no
Name: libmlx5-ve
Version: 1.2.3
Release: 1%{?dist}
Summary: Mellanox ConnectX-IB InfiniBand HCA Userspace Driver

Group: System Environment/Libraries
License: GPLv2 or BSD
Url: http://openfabrics.org/
Source: libmlx5-%{version}.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires: libibverbs-ve-devel >= 1.2.1
BuildRequires: libsysve-devel
Requires: libibverbs-ve >= 1.2.1
Requires: libsysve
%if %{_with_valgrind}
BuildRequires: valgrind-devel
%endif

%description
libmlx5 provides a device-specific userspace driver for Mellanox
ConnectX HCAs for use with the libibverbs library.

%package devel
AutoReqProv: no
Summary: Development files for the libmlx5 driver
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
Provides: libmlx5-static = %{version}-%{release}

%description devel
Static version of libmlx5 that may be linked directly to an
application, which may be useful for debugging.

%prep
%setup -q -n libmlx5-1.2.3

%build
%if %{_with_valgrind}
%configure %{?configure_options} --libdir=%{_libdir}/mlnx_ofed/valgrind --with-valgrind
make %{?_smp_mflags}
make DESTDIR=$RPM_BUILD_DIR/%{name}-%{version}/valgrind install
rm -f $RPM_BUILD_DIR/%{name}-%{version}/valgrind/%{_libdir}/mlnx_ofed/valgrind/*.*a
make clean
%endif

%configure %{configure_options}
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=%{buildroot} install
%if %{_with_valgrind}
mkdir -p %{buildroot}/%{_libdir}/mlnx_ofed
cp -a $RPM_BUILD_DIR/%{name}-%{version}/valgrind/%{_libdir}/mlnx_ofed/valgrind %{buildroot}/%{_libdir}/mlnx_ofed
%endif
# remove unpackaged files from the buildroot
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf $RPM_BUILD_ROOT

# %post -p /sbin/ldconfig

# %postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libmlx5*.so.*
%{_libdir}/libmlx5-rdmav2.so
%if %{_with_valgrind}
%{_libdir}/mlnx_ofed/valgrind/libmlx5*.so.*
%{_libdir}/mlnx_ofed/valgrind/libmlx5-rdmav2.so
%endif
%{_sysconfdir}/libibverbs.d/mlx5.driver
%doc AUTHORS COPYING README

%files devel
%defattr(-,root,root,-)
%{_libdir}/libmlx5.a
%{_libdir}/libmlx5.so
%if %{_with_valgrind}
%{_libdir}/mlnx_ofed/valgrind/libmlx5.so
%endif
%{_prefix}/include/infiniband/

%changelog
* Thu Jul 05 2018 NEC Corporation - 1.2.0
- Porting to VE architecture based on Mellanox OFED 4.3-3

