%{!?KVER: %define KVER %(uname -r)}
%define REL_KVER	%(echo %{KVER} | sed -s "s/\.el.\.x86_64//" | tr - _)

%define debug_package %{nil}

Name:		ve_peermem
Version:	1.2.1
Release:	%{REL_KVER}_MLNX_OFED_4.3.el7
Summary:	VE peer memory client kernel module

Group:		System Environment/Libraries
License:	GPLv2 or BSD
Source0:	ve_peermem-%{version}.tar.gz

BuildRequires:	gcc kernel-headers
BuildRequires:	mlnx-ofa_kernel-devel = 4.3
Requires:	kernel-uname-r = %{KVER}
Requires:	mlnx-ofa_kernel = 4.3

%description
VE peer memory client kernel modules.

%prep
%setup -q

%build
make %{?_smp_mflags} KVER=%{KVER} VER=%{version}

%install
make install DESTDIR=%{buildroot} KVER=%{KVER}

%files
/lib/modules/%{KVER}/extra
/etc/udev/rules.d/*
/etc/init.d/*
/etc/dracut.conf.d/*

%pre
if [ ! $1 -eq 1 ]
then
	# update
	/etc/init.d/ve_peermem stop
fi

%post
if [ $1 -eq 1 ]
then
	# install
	/sbin/depmod -a %{KVER}
	/sbin/chkconfig --add ve_peermem
fi

%preun
if [ $1 -eq 0 ]
then
	# uninstall
	/etc/init.d/ve_peermem stop
	/sbin/chkconfig --del ve_peermem
fi

%postun
/sbin/depmod -a %{KVER}
if [ -x /sbin/weak-modules ]; then
	echo "/lib/modules/%{KVER}/extra/ve_peermem.ko" | \
	    /sbin/weak-modules --no-initramfs --remove-modules
fi

%triggerpostun -- %{name} < 1.2.1
/sbin/chkconfig --add ve_peermem

%changelog

